
#include "../poboxlib.h"
#include <stdlib.h>
#include <stdio.h>

template <class Ty>
void assert_equal(const Ty& expected, const Ty& actual)
{
    if (expected != actual) {
        printf("failed: expected = %d, actual = %d\n", expected, actual);
        throw -1;
    }
    else
        printf("passed.\n");
}

static POBoxDict* dict = NULL;

void test1()
    // Υƥ
{
    printf("%s\n", __func__);

    dict = static_cast<POBoxDict*>(malloc(sizeof(POBoxDict)));
    dict->name = "test.dic";
    pobox_usedict(dict);

    printf("size = %d\n", pobox_entries(dict));
    assert_equal(3, pobox_entries(dict));

    assert_equal(0, pobox_regword(dict, "դϤܤ", "", NULL));
    assert_equal(0, pobox_regword(dict, "Ӥ", "", "餦"));

    printf("size = %d\n", pobox_entries(dict));
    assert_equal(6, pobox_entries(dict)); // contextꤹȡ2ȥϿ

    dict->name = "test.dic.out";
    pobox_save(dict);
}

void test2()
    // 
{
    printf("%s\n", __func__);

    assert_equal(6, pobox_entries(dict));
    printf("size = %d\n", pobox_entries(dict));

    int n = pobox_search2("");
    assert_equal(3, n);

    char* cands[100];
    char* pats[100];
    assert_equal(3, pobox_getcands(cands, pats, 0, n));
    for (int i = 0; i < n; i++) {
        printf("cand = '%s' pat = '%s'\n", cands[i], pats[i]);
    }
}

int main()
{
    pobox_init();
    test1();
    test2();
    return 0;
}
